package at.jku.students;

import at.jku.ssw.Set;
import at.jku.ssw.Iterator;
import at.jku.ssw.TreeNode;
import at.jku.ssw.DotMaker;

/** A sorted set of characters backed by a binary tree. */
public class BinaryTreeSet extends Set {

  TreeNode root;
  
  /** Adds the value to this set. */
  public void add(char value) {
    if (get(value)) {
      return;
    }
    root = add0(root, value);
  }
  
  private static TreeNode add0(TreeNode node, char value) {
    if (node == null) {
      node = new TreeNode(value);
    } else if (value < node.value) {
      node.left = add0(node.left, value);
    } else { // value > node.value
      node.right = add0(node.right, value);
    }
    return node;
  }
  
  /** Returns <code>true</code> if the value is present in the set, otherwise <code>false</code>. */
  public boolean get(char value) {
    return get0(root, value);
  }
  
  private static boolean get0(TreeNode node, char value) {
    if (node == null) {
      return false;
    } else if (value == node.value) {
      return true;
    } else if (value < node.value) {
      return get0(node.left, value);
    } else {
      return get0(node.right, value);
    }
  }
  
  /** Removes the value from this set. */
  public boolean remove(char value) {
    return false;
  }
 
  /** Returns the number of values in this set. */
  public int size() {
    return size0(root);
  }
  
  private static int size0(TreeNode node) {
    if (node == null) {
      return 0;
    } else {
      return 1 + size0(node.left) + size0(node.right);
    }
  }
  
  /** Returns an iterator of the values in this set. */
  public Iterator iterator() {
    char[] values = new char[size()];
    int index = 0;
    inorder0(root, values, index);
    return new BinaryTreeIterator(values);
  }
  
  private static int inorder0(TreeNode node, char[] values, int index) {
    if (node != null) {
      index = inorder0(node.left, values, index);
      values[index++] = node.value;
      index = inorder0(node.right, values, index);
    }
    return index;
  }

  /** Returns a new set with the elements contained in this set but not contained in other. */
  public BinaryTreeSet diff(Set set) {
    return null;
  }
  
  /** Returns a new set with the elements of this set and other. */
  public BinaryTreeSet union(Set set) {
    return null;
  }

  /** Returns a new set with the elements contained both sets this and other. */
  public BinaryTreeSet intersect(Set set) {
    return null;
  }
  
  /** Returns a new set with the elements contained in this set in the range between from and to. */
  public BinaryTreeSet subset(char from, char to) {
    return null;
  }

  /** Creates a dot string which represents the binary tree. */
  public String makeDot() {
    return DotMaker.makeDotForBinaryTree(root);
  }
  
}